//+------------------------------------------------------------------+
//|                                          Sample_SOM_Net_Base.mq5 |
//|                                            Copyright 2015, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#include "Include\\SOM_Net_Base.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//---  ,       
input string SOM_Net="SOM\\SOM_Net";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CSOM_Net_Base som;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---      SOM\\SOM_Net.somnet
   if(som.DownloadNet(SOM_Net))
     {
      //---         
      double vector[8]={91.73,1.03,0.07,0.01,122,26.2295082,7,6};
      //---           
      int ND=som.BestMatchingNode(vector);
      //---            
      som.GetNode(ND);
      //---            
      string nod="best node ",vct="datavector";
      for(int i=0;i<som.GetDimension();i++)
        {
         //---             
         nod+="["+DoubleToString(som.public_node.GetWeight(i),2)+"]";
         //---           
         vct+="["+DoubleToString(vector[i],2)+"]";
        }
      //---      
      Print(nod);
      //---    
      Print(vct);
      //---   
      //---  ,     
      som.InitSetByteMap(0,1);
      som.InitSetByteMap(1,1);
      som.InitSetByteMap(2,1);
      som.InitSetByteMap(3,0);
      som.InitSetByteMap(4,1);
      som.InitSetByteMap(5,1);
      som.InitSetByteMap(6,0);
      som.InitSetByteMap(7,0);
      //---           
      ND=som.BestMatchingNode(vector);
      //---            
      som.GetNode(ND);
      //---            
      nod="best node ";vct="datavector";
      for(int i=0;i<som.GetDimension();i++)
        {
         //---             
         nod+="["+DoubleToString(som.public_node.GetWeight(i),2)+"]";
         //---           
         vct+="["+DoubleToString(vector[i],2)+"]";
        }
      //---      
      Print(nod);
      //---    
      Print(vct);
     }
   else
     {
      Print("Expert      "+SOM_Net+".somnet");
     }
//---         
   ExpertRemove();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){}
//+------------------------------------------------------------------+
