//+------------------------------------------------------------------+
//|                                          Sample_SOM_Net_Data.mq5 |
//|                                            Copyright 2015, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#include "Include\\SOM_Net_Data.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//---  ,       
input string SOM_Net="SOM\\SOM_Net";
//---  ,    
input string DataFileName="SOM\\optim.csv";
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CSOM_Net_Data som;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---      SOM\\SOM_Net.somnet
   if(som.DownloadNet(SOM_Net))
     {
      //---      SOM\\optim.csv      
      if(som.LoadPatternDataFromFile(DataFileName))
        {
         double vector[];
         //---             
         for(int PTRN=0; PTRN<som.GetTotalsPatterns() && !IsStopped(); PTRN++)
           {
            //---    PTRN (  )   vector[]           
            if(som.GetPatterns(PTRN,vector))
              {
               //---           
               int ND=som.BestMatchingNode(vector);
               //---            
               som.GetNode(ND);
               //---            
               string nod="best node ",vct="datavector";
               for(int i=0;i<som.GetDimension();i++)
                 {
                  //---             
                  nod+="["+DoubleToString(som.public_node.GetWeight(i),2)+"]";
                  //---           
                  vct+="["+DoubleToString(vector[i],2)+"]";
                 }
               //---
               Print(" ",som.GetTitlesPatterns(PTRN),":     =",ND,
                     "   = ",som.public_node.nX(),"x",som.public_node.nY()
                     );
               //---      
               Print(nod);
               //---    
               Print(vct);
               //---
               Sleep(10);
              }
           }
        }
      else Print("Expert       "+DataFileName);
     }
   else Print("Expert      "+SOM_Net+".somnet");
//---    
   ExpertRemove();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){}
//+------------------------------------------------------------------+
