//+------------------------------------------------------------------+
//|                                         Sample_SOM_Net_Train.mq5 |
//|                                            Copyright 2015, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#include "Include\\SOM_Net_Train.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//---  ,       
input string SOM_Net="SOM\\SOM_Net";
//---  ,    
input string DataFileName="SOM\\optim.csv";
//---  ,    
input int Iteration=10000;
//---  ,     X
input int CellsX=50;
//---  ,     Y
input int CellsY=50;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CSOM_Net_Train som;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---      SOM\\optim.csv  
   if(som.LoadPatternDataFromFile(DataFileName))
     {
      //---          
      som.InitParameters(Iteration,CellsX,CellsY);
      //---        
      som.Train();
      //---         
      som.SaveNet(SOM_Net);
      //---       
      double vector[];
      //---      
      for(int PTRN=0; PTRN<som.GetTotalsPatterns() && !IsStopped(); PTRN++)
        {
         //---    PTRN (  )   vector[]  
         if(som.GetPatterns(PTRN,vector))
           {
            //---      
            int ND=som.BestMatchingNode(vector);
            //---       
            som.GetNode(ND);
            //---       
            string nod="best node ",vct="datavector";
            for(int i=0;i<som.GetDimension();i++)
              {
               //---     
               nod+="["+DoubleToString(som.public_node.GetWeight(i),2)+"]";
               //---   
               vct+="["+DoubleToString(vector[i],2)+"]";
              }
            //---
            Print(" ",som.GetTitlesPatterns(PTRN),":     =",ND,
                  "   = ",som.public_node.nX(),"x",som.public_node.nY()
                  );
            //---      
            Print(nod);
            //---    
            Print(vct);
            //---
            Sleep(10);
           }
        }
     }
   else Print("Expert       "+DataFileName);
//---    
   ExpertRemove();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick(){}
//+------------------------------------------------------------------+
